----------------------------------------------------------------------------------
----------------------------------------------------------------------------------
--                                                                              --
-- Name:    eval.e - Dynamic Euphoria Code Interpreter                          --
-- Version: 1                                                                   --
-- Author:  Alex Chamberlain                                                    --
--                                                                              --
----------------------------------------------------------------------------------
--                                                                              --
-- Eval.e                                                                       --
-- Copyright Alex Chamberlain 2005                                              --
-- euphoria@yourpixels.co.uk                                                    --
--                                                                              --
-- Basically, I tried to keep it simple - it was too simple and I needed help   --
-- from the EUforum - thanks mainly to Juergen Luethje but also every body else --
-- that helped! Now, we are left with this - at the moment it is basically for  --
-- running console programs, that don't actually for input.                     --
--                                                                              --
-- It does add a random number so that you can expect multiple programs to work --
-- with this library with no confusion.                                         --
--                                                                              --
-- Basically, there is one function eval(sequence script). Simply pass it the   --
-- script and it will return the result. If there is an error, it will return   --
-- EVAL_ERR_RET. Your program then needs to generate a message depening on if   --
-- EVAL_ERROR is equal to EVAL_WRITE_ERR or EVAL_READ_ERR - see demo.ex!        --
--                                                                              --
-- Very soon I will add functions to pass constants. Really, how much work does --
-- the source needs to be compiled as a dll? I am not a C programmer!           --
--                                                                              --
-- Chers,                                                                       --
--  Alex                                                                        --
--                                                                              --
----------------------------------------------------------------------------------
-- Developers can use this version free of charge for any purpose ... bla bla   --
-- And if anything happens its not my fault - its yours!                        --
----------------------------------------------------------------------------------
----------------------------------------------------------------------------------

include misc.e
include file.e

global constant
EVAL_RAND_NUM = sprint(rand(999999)),
EVAL_PROG_NAME = "eval_prg" & EVAL_RAND_NUM & ".tmp",
EVAL_RES_NAME = "eval_res" & EVAL_RAND_NUM & ".tmp",
EVAL_FLAG_NAME = "eval_flag" & EVAL_RAND_NUM & ".tmp",
EVAL_ERR_RET = -1,
EVAL_WRITE_ERR = 1,
EVAL_READ_ERR  = 2

global integer EVAL_ERROR

EVAL_ERROR = 0

global function eval (sequence script)
	sequence plat, ret, del
	integer tmp_fn
	object line, eu

	-- write a temporary program for evaluating the expression and
	-- writing the result to another temporary file
	tmp_fn = open(EVAL_PROG_NAME, "w")
	if tmp_fn = -1 then
		EVAL_ERROR = EVAL_WRITE_ERR
		return EVAL_ERR_RET
	end if
	
	puts(tmp_fn, script)
	puts(tmp_fn, "\n\ninteger eval_flag_fn\n"
		& "eval_flag_fn = open(\"" & EVAL_FLAG_NAME & "\", \"w\")\n"
		& "print(eval_flag_fn, 123)\n"
		& "close(eval_flag_fn)\n"
		)
	close(tmp_fn)

	-- run the temporary program
	if platform() = DOS32 then
		plat = "ex"
		del = "DEL"
	elsif platform() = WIN32 then
		plat = "exwc"
		del = "DEL"
	elsif (platform() = LINUX) or (platform() = FREEBSD) then
		plat = "exu"
		del = "rm"
	end if
	
	eu = getenv("EUDIR")

	if equal(plat, "exu") and atom(eu) then
		system("./" & plat & " " & EVAL_PROG_NAME & " > " & EVAL_RES_NAME, 2)
	else
		system(plat & " " & EVAL_PROG_NAME & " > " & EVAL_RES_NAME, 2)
	end if

	while atom(dir(EVAL_FLAG_NAME)) do
	end while

	-- read the content of the temporary result file,
	-- and convert it to a number
	tmp_fn = open(EVAL_RES_NAME, "r")
	if tmp_fn = -1 then
		EVAL_ERROR = EVAL_READ_ERR
		return EVAL_ERR_RET
	end if

	ret = {}
	while 1 do
		line = gets(tmp_fn)
		if atom(line) then
			exit
		end if
		ret &= line
	end while
	close(tmp_fn)

	system(del & " *" & EVAL_RAND_NUM & ".tmp", 2)

	return ret
end function